=== debian/changelog ===
libsigmf (1.0.2-4) unstable; urgency=medium

  * Use -DCMAKE_POLICY_VERSION_MINIMUM=3.5 (Closes: #1113200)

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 13 Oct 2025 20:47:21 -0400

libsigmf (1.0.2-3) unstable; urgency=medium

  * Rebuild against latest flatbuffers (Closes: #1076177)
  * update Standards-Version (no changes needed), Multi-Arch: same

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 14 Jul 2024 15:50:01 -0400

libsigmf (1.0.2-2) unstable; urgency=medium

  * upload to unstable

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 13 Jul 2023 23:48:18 -0400

libsigmf (1.0.2-1) experimental; urgency=medium

  * Initial release of the Debian package (Closes: #1001743)

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 03 Jan 2023 15:42:45 -0500

libsigmf (0.0.0.8ac7dbc-1) unreleased; urgency=medium

  * 8ac7dbc
  * start packaging

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 22 Sep 2021 13:17:21 -0400
