=== debian/control ===
Source: libsigmf
Section: science
Priority: optional
Maintainer: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libflatbuffers-dev,
               nlohmann-json3-dev
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://github.com/deepsig/libsigmf
Vcs-Browser: https://salsa.debian.org/science-team/libsigmf
Vcs-Git: https://salsa.debian.org/science-team/libsigmf.git

Package: libsigmf
Architecture: any
Multi-Arch: same
Depends: libflatbuffers-dev,
         nlohmann-json3-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Description: SigMF data format handling library
 A header-only C++ library for working with SigMF metadata.
 To use libsigmf, your application needs to #include <sigmf.h>
 and link to libflatbuffers.so.
 .
 The Signal Metadata Format (SigMF) specifies a way to describe sets
 of recorded digital signal samples with metadata written in
 JSON. SigMF can be used to describe general information about a
 collection of samples, the characteristics of the system that
 generated the samples, features of signals themselves, and the
 relationship between different recordings.
