=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_SYSTEM_JSON=ON -DUSE_SYSTEM_FLATBUFFERS=ON \
                             -DCMAKE_POLICY_VERSION_MINIMUM=3.5
